<%@ include file="includes/jspheader.jsp" %>
<%@ include file="includes/jspencoding.jsp" %>

<%@ include file="includes/logincheck.jsp" %>

<%@ page import="com.esko.webcenter.jsp.*" %>
<%@ page import="com.esko.webcenter.cache.*" %>
<%@ page import="com.esko.webcenter.src.root.*" %>
<%@ page import="com.esko.webcenter.src.root.view.*" %>
<%@ page import="com.esko.webcenter.src.xml.*" %>
<%@ page import="com.esko.webcenter.src.util.*" %>
<%@ page import="com.esko.util.*" %>

<%@ page import="java.net.URLEncoder" %>

<%@ page import="java.util.Vector" %>
<%@ page import="java.sql.*" %>

<%
	// clean up the tempfiles from the last request
	TempFileMgr.getTempFileMgr(session).deleteAllTempFiles();
 %>
 
<%
	String attrCatView = request.getParameter("attrcatview"); // specify a non-standard Attribute category view to use (for now printing only?)
	String pageTitleString = request.getParameter("pagetitle");
	String xmlMenuName = request.getParameter("xmlmenuname");
	String print = request.getParameter("print"); // 0 (default): non-print mode with navigation; 1: print mode with print link; 2: print mode without print link
	String showImage = request.getParameter("showimage"); // display image in page
	String maxPixSize = request.getParameter("maxpixsize"); // max image dimension x, y in pixels
	String maxPixSizeX = request.getParameter("maxpixsizex"); // max image dimension x in pixels
	String maxPixSizeY = request.getParameter("maxpixsizey"); // max image dimension y in pixels
	
	boolean isPrintPage = "1".equals(print) || "2".equals(print);  
	String pageName = isPrintPage ? "docdetailsprintattrs" : "docdetailsattrs";
	String pageTitle = StringUtils.checkForValue(pageTitleString) ? pageTitleString : "Document Details - Attributes";
	String xmlName = StringUtils.checkForValue(xmlMenuName) ? xmlMenuName : pageName; 
	
	// Check database flags to see whether we need to hide the JDF and the change category button
	ProfileDefaultTM profileDefault= DBTMUtils.findBean(response, session, ProfileDefaultTM.class);
	if (profileDefault == null)
		return;	
	
	String hideJDFKey = "WC_CATEGORY_HIDE_JDF_BUTTONS"; 
	String hideJDFButtonsString = profileDefault. load(LoginMgr.getLoginMgr(session).getLoginID(), hideJDFKey);
	boolean hideJDFButtons = hideJDFButtonsString!= null && hideJDFButtonsString.equals("1");

	String onlyAdminCanChangeCategoryKey = "WC_CATEGORY_ONLY_CHANGED_BY_ADMIN"; 
	String onlyAdminCanChangeCategoryString = profileDefault. load(LoginMgr.getLoginMgr(session).getLoginID(), onlyAdminCanChangeCategoryKey);
	boolean onlyAdminCanChangeCategory = onlyAdminCanChangeCategoryString!= null && onlyAdminCanChangeCategoryString.equals("1");


	DocDetailsPageHelper docDetailsPageHelper = new DocDetailsPageHelper(session, application, request, response, out, pageName, xmlName, pageTitle);
	if (isPrintPage)
		docDetailsPageHelper.setMakeCurDocTypeDefPage(false); // never make default landing page
	if (!docDetailsPageHelper.initialize())
		return;
  
	DocVersionView docVersionView = docDetailsPageHelper.getDocVersionView();
	DocVersion docVersion = docVersionView.getDocVersion();
	
	boolean canModifyAttrs = DocumentUtils.canChangeApprovedDocumentAttributes(response, session, application, docVersion);
	boolean showNoCategoryMessage = false;

	if (!StringUtils.checkForValue(docVersion.getAttributeCategoryID()))
	{
		if (!isPrintPage && docDetailsPageHelper.getDocUpdatePerm() && canModifyAttrs)
		{
			// redirect to the change grouping page if the doc is editable and does not have a category defined
	  		DocDetailsUtils.sendRedirect(response, request, "docdetailsattrscategory.jsp", docVersion.getObjectID(), null);
			return;
		}
		else
		{
			//show 'This document has no attribute category assigned' message
			showNoCategoryMessage = true;
		}
	}

	// make sure it has all the data for doc info defined (attributes)
	
				
	// generate the xml
  JSPDocXMLWriter xmlWriter = docDetailsPageHelper.getJSPDocXMLWriter();
	if (!docDetailsPageHelper.startXml())
	  return;
	xmlWriter.writeXmlUserUnits(LoginMgr.getLoginMgr(session).getUserUnits(session));
	
	// write out a notification
	xmlWriter.writeXmlNotification(session); 
	
	
	// Get category details in XML
 	// Already written by general document XML writer (needed by header)
	// AttributeUtils.generateCategoryXml(response, session,xmlWriter,docVersion.getAttributeCategoryID());

  	
    // write default due date time
    String defaultDueDateTime = ConfigurationMgr.getInstance().getDefaultDueDateTime();
    xmlWriter.writeXmlString(Xml.getFieldXml("default_due_date_time", defaultDueDateTime));
 
   // write out attribute category is downloadable or not
    if (StringUtils.checkForValue(docVersion.getAttributeCategoryID()))
	{
    	if(docDetailsPageHelper.isAttributeCategoryDownloadable(docVersion.getAttributeCategoryID(),session)){
    		 xmlWriter.writeXmlString("<is_downloadable>1</is_downloadable>"+Xml.NEWLINEPARAM);
    	} else {
    		 xmlWriter.writeXmlString("<is_downloadable>0</is_downloadable>"+Xml.NEWLINEPARAM);
    	}
	}
   
	if (docDetailsPageHelper.getDocUpdatePerm() && canModifyAttrs)
		xmlWriter.writeXmlString("<is_editable>1</is_editable>"+Xml.NEWLINEPARAM);
		
	if (showNoCategoryMessage)
	{
		xmlWriter.writeXmlString("<no_attr_category_msg/>"+Xml.NEWLINEPARAM);
	}
	
	if (hideJDFButtons){
		xmlWriter.writeXmlString("<hide_jdf_buttons>1</hide_jdf_buttons>"+Xml.NEWLINEPARAM);
	} 
	
	if (onlyAdminCanChangeCategory && !LoginMgr.getLoginMgr(session).isAdmin() ){
		xmlWriter.writeXmlString("<can_change_category>0</can_change_category>"+Xml.NEWLINEPARAM);
	} 	
	
	// write print parameter
	if (StringUtils.checkForValue(print)) 
	{
		xmlWriter.writeXmlString("<is_printing>"+XMLUtils.encodeXml(print)+"</is_printing>"+Xml.NEWLINEPARAM);
	}

	// write showImage parameter
	if (StringUtils.checkForValue(showImage)) 
	{
		xmlWriter.writeXmlString("<showimage>"+XMLUtils.encodeXml(showImage)+"</showimage>"+Xml.NEWLINEPARAM);
		if (StringUtils.checkForValue(maxPixSize)) 
			xmlWriter.writeXmlString("<maxpixsize>"+XMLUtils.encodeXml(maxPixSize)+"</maxpixsize>"+Xml.NEWLINEPARAM);
		if (StringUtils.checkForValue(maxPixSizeX)) 
			xmlWriter.writeXmlString("<maxpixsizex>"+XMLUtils.encodeXml(maxPixSizeX)+"</maxpixsizex>"+Xml.NEWLINEPARAM);
		if (StringUtils.checkForValue(maxPixSizeY)) 
			xmlWriter.writeXmlString("<maxpixsizey>"+XMLUtils.encodeXml(maxPixSizeY)+"</maxpixsizey>"+Xml.NEWLINEPARAM);		
	}
		
	// write attrCatView parameter
	if (StringUtils.checkForValue(attrCatView)) 
	{
		xmlWriter.writeXmlString("<attrcatview>"+XMLUtils.encodeXml(attrCatView)+"</attrcatview>"+Xml.NEWLINEPARAM);
		
		String menuitem3 = request.getParameter("menuitem3");
		menuitem3=(menuitem3==null?"":menuitem3);
		String menusel3 = request.getParameter("menusel3");
		menusel3=(menusel3==null?"":menusel3);
		String docVerID = request.getParameter("docVerID");
		docVerID=(docVerID==null?"":docVerID);
		String menu_file = request.getParameter("menu_file");
		menu_file=(menu_file==null?"":menu_file);
		
		String returnUrl = "docdetailsattrs.jsp" +
				"?attrcatview=" + URLEncoder.encode(attrCatView, "UTF-8") +
				"&menuitem3=" + URLEncoder.encode(menuitem3, "UTF-8") +
				"&menusel3=" + URLEncoder.encode(menusel3, "UTF-8") +
				"&docVerID=" + URLEncoder.encode(docVerID, "UTF-8") +
				"&menu_file=" + URLEncoder.encode(menu_file, "UTF-8");
		xmlWriter.writeXmlString("<attrcatviewreturnurl>" + XMLUtils.encodeXml(returnUrl) + "</attrcatviewreturnurl>");
	}
	
	// Finish up the xml and transform the page
	docDetailsPageHelper.endXml();
	docDetailsPageHelper.transformXml();
 %>