<%@ include file="includes/jspheader.jsp" %>
<%@ include file="includes/jspencoding.jsp" %>

<%@ include file="includes/logincheck.jsp" %>

<%@ page import="com.esko.webcenter.jsp.*" %>
<%@ page import="com.esko.webcenter.src.root.*"%>
<%@ page import="com.esko.webcenter.cache.*" %>
<%@ page import="com.esko.webcenter.src.root.view.*"%>
<%@ page import="com.esko.webcenter.src.xml.*" %>
<%@ page import="com.esko.webcenter.src.util.*" %>
<%@ page import="com.esko.util.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.sql.*" %>

<%@ page import="java.net.URLEncoder" %>

<%@ page import="com.esko.webcenter.exceptions.*" %>

<%
	// clean up the tempfiles from the last request
	TempFileMgr.getTempFileMgr(session).deleteAllTempFiles();
%>

<%
	String attrCatView = request.getParameter("attrcatview"); // specify a non-standard Attribute category view to use (for now printing only?)
	String pageTitleString = request.getParameter("pagetitle");
	//	String xmlMenuName = request.getParameter("xmlmenuname");
	String print = request.getParameter("print"); // 0 (default): non-print mode with navigation; 1: print mode with print link; 2: print mode without print link
	
	boolean isPrintPage = "1".equals(print) || "2".equals(print);
	String pageName = isPrintPage ? "projdetailsprintattrs" : "projdetailsattrs";
	String pageTitle = StringUtils.checkForValue(pageTitleString) ? pageTitleString
			: "Project Details - Attributes";
	//	String xmlName = StringUtils.checkForValue(xmlMenuName) ? xmlMenuName : pageName;
	
	// Check database flags to see whether we need to hide the JDF and the change category button
	ProfileDefaultTM profileDefault= DBTMUtils.findBean(response, session, ProfileDefaultTM.class);
	if (profileDefault == null)
		return;	
	
	String hideJDFKey = "WC_CATEGORY_HIDE_JDF_BUTTONS"; 
	String hideJDFButtonsString = profileDefault. load(LoginMgr.getLoginMgr(session).getLoginID(), hideJDFKey);
	boolean hideJDFButtons = hideJDFButtonsString!= null && hideJDFButtonsString.equals("1");

	String onlyAdminCanChangeCategoryKey = "WC_CATEGORY_ONLY_CHANGED_BY_ADMIN"; 
	String onlyAdminCanChangeCategoryString = profileDefault. load(LoginMgr.getLoginMgr(session).getLoginID(), onlyAdminCanChangeCategoryKey);
	boolean onlyAdminCanChangeCategory = onlyAdminCanChangeCategoryString!= null && onlyAdminCanChangeCategoryString.equals("1");

	ProjDetailsPageHelper projDetailsPageHelper = new ProjDetailsPageHelper(session, application, request,
			response, out, pageName, pageTitle);
	if (!projDetailsPageHelper.initialize())
		return;

	WCProject curProject = projDetailsPageHelper.getWcProject();
	
	// We use session variables to make the selected view persistent. Becuase we only want to store the view in a given project context, 
	// we also keep track of the project that is using the view. If we switch projects, we reset the session variables.
	final String CATEGORY_VIEW = "CATEGORY_VIEW";
	final String CATEGORY_PROJECTID = "CATEGORY_VIEW_PROJECTID";
	
	String categoryViewProjectID = (String)session.getAttribute(CATEGORY_PROJECTID);	
	if (IdGenerator.isIDFormat( categoryViewProjectID ) && !categoryViewProjectID.equals( curProject.getObjectID()) ){
		session.setAttribute(CATEGORY_VIEW, "");
		session.setAttribute(CATEGORY_PROJECTID, "");		
	}

	// redirect to the change grouping page if the project
	// is editable and does not have a category defined	  
	boolean showNoCategoryMessage = false;
	if (!StringUtils.checkForValue(curProject.getCategoryID())) {
		// There is no category selected.
		// check whether the user has the change properties right. In that case, redirect to the proj details att category page.
		// in the other case, stay on this page 
		boolean hasChangePropertiesPerm = SecurityUtils.checkEffectiveProjectSecurity(session,
				Permission.UPDATE, curProject.getObjectID(), projDetailsPageHelper.getProjectTM());

		if (!isPrintPage && hasChangePropertiesPerm) {
			ProjDetailsUtils.sendRedirect(response, request, "projdetailsattrscategory.jsp",
					curProject.getObjectID(), null);
			return;
		}
		else
		{
			//show 'This document has no attribute category assigned' message
			showNoCategoryMessage = true;
		}
	} else{
		// when a category view is used, store it in a session variable so that we can get it back when returning to the attributes page
		if (StringUtils.checkForValue(attrCatView)) {
			session.setAttribute(CATEGORY_VIEW, attrCatView);
			session.setAttribute(CATEGORY_PROJECTID, curProject.getObjectID());		
		} else{
			session.removeAttribute(CATEGORY_VIEW);
			session.removeAttribute(CATEGORY_PROJECTID);	 
		}
	}

	ProjectTM projectTM = projDetailsPageHelper.getProjectTM();
	
	// generate the xml
	JSPDocXMLWriter xmlWriter = projDetailsPageHelper.getJSPDocXMLWriter();
	if (!projDetailsPageHelper.startXml())
		return;

	// write out a notification
	xmlWriter.writeXmlNotification(session);


	// write default due date time
	String defaultDueDateTime = ConfigurationMgr.getInstance().getDefaultDueDateTime();
	xmlWriter.writeXmlString(Xml.getFieldXml("default_due_date_time", defaultDueDateTime));

	if (hideJDFButtons){
		xmlWriter.writeXmlString("<hide_jdf_buttons>1</hide_jdf_buttons>"+Xml.NEWLINEPARAM);
	} 
	
	if (onlyAdminCanChangeCategory && !LoginMgr.getLoginMgr(session).isAdmin() ){
		xmlWriter.writeXmlString("<can_change_category>0</can_change_category>"+Xml.NEWLINEPARAM);
	}

	if (showNoCategoryMessage)
	{
		xmlWriter.writeXmlString("<no_attr_category_msg/>"+Xml.NEWLINEPARAM);
	}

	 // write out attribute category is downloadable or not
    if (StringUtils.checkForValue(curProject.getCategoryID()))
	{
    	if(projDetailsPageHelper.isAttributeCategoryDownloadable(curProject.getCategoryID(),session)){
    		 xmlWriter.writeXmlString("<is_downloadable>1</is_downloadable>"+Xml.NEWLINEPARAM);
    	} else {
    		 xmlWriter.writeXmlString("<is_downloadable>0</is_downloadable>"+Xml.NEWLINEPARAM);
    	}
	}
	
	// write print parameter
	if (StringUtils.checkForValue(print)) {
		xmlWriter.writeXmlString("<is_printing>" + XMLUtils.encodeXml(print) + "</is_printing>" + Xml.NEWLINEPARAM);
	}
	if ( onlyAdminCanChangeCategory && !LoginMgr.getLoginMgr(session).isAdmin() ){
		xmlWriter.writeXmlString("<can_change_category>0</can_change_category>"+Xml.NEWLINEPARAM);
	} 	

	// write attrCatView parameter
	if (StringUtils.checkForValue(attrCatView)) {
		xmlWriter.writeXmlString("<attrcatview>" + XMLUtils.encodeXml(attrCatView) + "</attrcatview>" + Xml.NEWLINEPARAM);
		
		String menuitem3 = request.getParameter("menuitem3");
		menuitem3=(menuitem3==null?"":menuitem3);
		String menusel3 = request.getParameter("menusel3");
		menusel3=(menusel3==null?"":menusel3);
		String projectID = request.getParameter("projectID");
		projectID=(projectID==null?"":projectID);
		String menu_file = request.getParameter("menu_file");
		menu_file=(menu_file==null?"":menu_file);
		
		String returnUrl = "projdetailsattrs.jsp" +
				"?attrcatview=" + URLEncoder.encode(attrCatView, "UTF-8") +
				"&menuitem3=" + URLEncoder.encode(menuitem3, "UTF-8") +
				"&menusel3=" + URLEncoder.encode(menusel3, "UTF-8") +
				"&projectID=" + URLEncoder.encode(projectID, "UTF-8") +
				"&menu_file=" + URLEncoder.encode(menu_file, "UTF-8");
		xmlWriter.writeXmlString("<attrcatviewreturnurl>" + XMLUtils.encodeXml(returnUrl) + "</attrcatviewreturnurl>");
	}

	// Finish up the xml and transform the page
	projDetailsPageHelper.endXml();
	projDetailsPageHelper.transformXml();
%>